﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace TileEditor
{
    public partial class mainForm : Form
    {
        #region zmienne
        int rzad, kolumna;
        int H, L;

        Graphics g;
        public string[] tiles_Sciezki;
        public int ileDostepnychTile;
        public int ileTileNaEkranie;
        public int wybranyTileNr;       //który tile jest teraz wybrany do rysowania
        
                                        
        

        Image[] tileImageList;
        int[,] tileDataList;
        public int tileNr;              //indeks w tablicy ostatniego tile'a

        
        
        Image[] blockImageList;
        int[,] blockDataList;
        int blockWidth, blockHeight;
        int blockTileWidth, blockTileHeight;
        public int blockNr;              //indeks w tablicy ostatniego bloku
        int ileBlockNaEkranie = 0;
        bool blockDrawing;             //czy jesteśmy w trybie rysowania bloku grafiki
        #endregion

        //konstruktor        
        public mainForm()
        {
            InitializeComponent();
            rzad = 0;
            kolumna = 0;
            AktualizujWspolrzedne();

            tileNr = 0;
            ileTileNaEkranie = 0;   
            tileImageList = new Image[100];
            tileDataList = new int[100, 5];

            blockNr = 0;
            ileBlockNaEkranie = 0;
            blockImageList=new Image[100];
            blockDataList = new int[100,7];
            blockDrawing = false;

        }

       
        
        //wczytywanie listy tilesów
        private void btnGraphicsRead_Click(object sender, EventArgs e)
        {
            string tile_Sciezka;
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
              
                tiles_Sciezki = new string[257];                   //tablica ze ścieżkami do plików graficznych budujących mapę
             
                string tiles_PlikLista = openFileDialog1.FileName;
                FileStream strumien = new FileStream(tiles_PlikLista, FileMode.Open,FileAccess.Read, FileShare.ReadWrite);
                StreamReader odczytywacz = new StreamReader(tiles_PlikLista);       
         
                int wczytanyTileNr=1;
                while (true)
                {
                   tile_Sciezka=odczytywacz.ReadLine();                    //czytaj ścieżkę do pliku z grafikua
                    if (tile_Sciezka==string.Empty) break;            //koniec plików -> koniec pętli
                    
                    tiles_Sciezki[wczytanyTileNr]=tile_Sciezka;                       //zapisz nazwę pliku do tablicy

                                        
                    wczytanyTileNr++;                                         //zwiększ zmienną - ilość wczytanych tiles

                 
                }
                wczytanyTileNr--; //wartość była zwiększana jeden raz za dużo
                ileDostepnychTile = wczytanyTileNr;
               
                odczytywacz.Close();
                strumien.Close();

                nudTileNr.Visible = true;
                btnTileObrazek.Visible = true;

                AktualizujTile(); //wyświetl nowy wybrany tile
            }    
        }
    
    
        //aktualizacja wybranego tile
        public void AktualizujTile()
        {
            wybranyTileNr = (int) nudTileNr.Value;
            Image obrazekTemp=(Image)new Bitmap(tiles_Sciezki[wybranyTileNr]);
            Image obrazek = (Image)new Bitmap(obrazekTemp,obrazekTemp.Width*2,obrazekTemp.Height*2);              
            btnTileObrazek.Image = obrazek;

            //zmień rozmiar kursora
            lblCursor.Width = obrazek.Width;
            lblCursor.Height = obrazek.Height;

            this.Refresh();
        }

        //zmiana wybranego tile'a

        private void nudTileNr_ValueChanged(object sender, EventArgs e)
        {
            if (nudTileNr.Value > ileDostepnychTile)          //przekroczono liczbe tilesów
            {
                nudTileNr.Value--;
                return;
            }

            if (nudTileNr.Value==0)
            {
                nudTileNr.Value++;
                return;
            }


            //zmień numer i obrazek
            AktualizujTile();
           
        }

        

        // sterowanie kursorem
        
        //za pomocą przycisków
        private void btnUp_Click(object sender, EventArgs e)
        {
        //zwykły tryb - przemieszczanie kursora
            if (blockDrawing == false)
            {

                if (rzad > 0)
                {
                    lblCursor.Top -= KrokKursora() * 16;
                    rzad -= KrokKursora();
                    AktualizujWspolrzedne();
                }
            }
        //określenie rozmiaru bloku
            else
            {
                if (blockHeight > 1)
                {
                    blockHeight--;
                    lblCursor.Height -= blockTileHeight;
                }
            }
        }

        private void btnDown_Click(object sender, EventArgs e)
        {
             //zwykły tryb - przemieszczanie kursora
            if (blockDrawing == false)
            {
                if (rzad < 23)
                {
                    lblCursor.Top += KrokKursora() * 16;
                    rzad += KrokKursora();
                    AktualizujWspolrzedne();
                }
            }
            //określenie rozmiaru bloku
            else
            {
                blockHeight++;
                lblCursor.Height += blockTileHeight;          
            }
        }

        private void btnLeft_Click(object sender, EventArgs e)
        {
             //zwykły tryb - przemieszczanie kursora
            if (blockDrawing == false)
            {
                if (kolumna > 0)
                {
                    lblCursor.Left -= KrokKursora() * 16;
                    kolumna -= KrokKursora();
                    AktualizujWspolrzedne();
                }
            }
            //określenie rozmiaru bloku
            else
            {
                if (blockWidth > 1)
                {
                    blockWidth--;
                    lblCursor.Width -= blockTileWidth;
                }
            }
        }

        private void btnRight_Click(object sender, EventArgs e)
        {
             //zwykły tryb - przemieszczanie kursora
            if (blockDrawing == false)
            {
                if (kolumna < 31)
                {
                    lblCursor.Left += KrokKursora() * 16;
                    kolumna += KrokKursora();
                    AktualizujWspolrzedne();
                }
            }
            //określenie rozmiaru bloku
            else
            {
                blockWidth++;
                lblCursor.Width += blockTileWidth;
            }
        }

        private int KrokKursora()
        {
            if (cbxFastCursor.Checked == false)
            {
                return 1;
            }
            else
            {
                return 4;
            }
        }

        //za pomocą myszy
        private void mainForm_MouseClick(object sender, MouseEventArgs e)
        {
            int X = e.X;
            int Y = e.Y;

            if (X>100&&X<612 && Y > 100 && Y < 484 &&  blockDrawing == false)     //klikniecie w obrębie mapy
            {
                X = X - (X % 16)+4;                //odejmij resztę z dzielenia przez 16
                Y = Y - (Y % 16)+4;                //aby dostać całkowitą wielokrotność szesnastu (+4 bo nie względem 96, a względem 100)
            lblCursor.Left = X;
            lblCursor.Top =Y;
            rzad = (int)((Y - 100) / 16);
            kolumna = (int)((X - 100) / 16);
            AktualizujWspolrzedne();
            }
        }

        
        
        
        //aktualizacja textboxów z opisem pozycji kursora
        public void AktualizujWspolrzedne()
        {
            tbxRzad.Text = rzad.ToString();
            tbxKolumna.Text = kolumna.ToString();

            H = (rzad >> 3)*8+64;
            tbxH.Text = H.ToString();

            L = (rzad & 7) * 32 + kolumna;
            tbxL.Text = L.ToString();
        }


        //umieść tile na mapie
        private void btnTile_Click(object sender, EventArgs e)
        {
            //twórz nowy obrazek o wymiarach takich jak kursor
            Image nowyTileTemp = (Image)new Bitmap(tiles_Sciezki[wybranyTileNr]);
            Image nowyTile = (Image)new Bitmap(nowyTileTemp, (int)lblCursor.Width, (int)lblCursor.Height);
            
            
            tileImageList[tileNr] = nowyTile;   //dodaj obrazek do tablicy

            //dodaj dane obrazka do tablicy
            tileDataList[tileNr, 0] = wybranyTileNr; //nr obrazka
            tileDataList[tileNr, 1] = H;             //współrzędne HL dla ZxSpectrum
            tileDataList[tileNr, 2] = L;
            tileDataList[tileNr, 3] = lblCursor.Top; //pozycja na ekranie
            tileDataList[tileNr, 4] = lblCursor.Left; 


            tileNr++;
            ileTileNaEkranie++;
            
            this.Refresh();

        }

        //umieść blok na mapie
        private void btnBlock_Click(object sender, EventArgs e)
        {
            //rozpoczęcie rysowania bloku tilesów
            if (blockDrawing == false)
            {
                blockDrawing = true;
                btnBlock.BackColor = Color.Red;
                
                blockWidth = 1;
                blockHeight = 1;
                blockTileWidth = lblCursor.Width; //rozmiary pojedynczego tile z bloku (rysowane na ekranie)
                blockTileHeight = lblCursor.Height;

                nudTileNr.Enabled = false;
            }

            else

            //zakończenie rysowania bloku tilesów
            {
                blockDrawing = false;
                btnBlock.BackColor = Color.FromName("Control");
                nudTileNr.Enabled = true;

                //twórz nowy obrazek z którego jest zbudowany blok
            Image nowyTileTemp = (Image)new Bitmap(tiles_Sciezki[wybranyTileNr]);
            Image nowyTile = (Image)new Bitmap(nowyTileTemp, blockTileWidth, blockTileHeight);

            blockImageList[blockNr] = nowyTile;   //dodaj obrazek do tablicy
            
            //dodaj dane obrazka do tablicy
            blockDataList[blockNr, 0] = wybranyTileNr; //nr obrazka
            blockDataList[blockNr, 1] = H;             //współrzędne HL dla ZxSpectrum
            blockDataList[blockNr, 2] = L;
            blockDataList[blockNr, 3] = blockWidth;   //szerokość i wysokość bloku
            blockDataList[blockNr, 4] = blockHeight;
            blockDataList[blockNr, 5] = lblCursor.Top; //pozycja na ekranie
            blockDataList[blockNr, 6] = lblCursor.Left;

            blockNr++;
            ileBlockNaEkranie++;

            lblCursor.Width = blockTileWidth;          //przywróć wymiary kursora takie jak jeden tile
            lblCursor.Height = blockTileHeight;

            this.Refresh();
            }

        }


        //odświeżenie ekranu - rysowanie tilesów
        private void mainForm_Paint(object sender, PaintEventArgs e)
        {
            g = e.Graphics;
            Image MyPicture = (Image)new Bitmap("Background.png");
            g.DrawImage(MyPicture,100,100,512,384);

            //rysowanie bloków
            if (ileBlockNaEkranie > 0)
            {
                for (int k = 0; k < ileBlockNaEkranie; k++)
                {
                    
                    //rysowanie jednego bloku
                    for (int szer = 0; szer < blockDataList[k, 3]; szer++)
                    {
                        for (int wys = 0; wys < blockDataList[k, 4]; wys++)
                        {
                            g.DrawImage(blockImageList[k],
                                        blockDataList[k, 6] + szer * blockImageList[k].Width,
                                        blockDataList[k, 5] + wys * blockImageList[k].Height);
                        }
                    }
                }


            }



            //rysowanie tilesów
            if (ileTileNaEkranie > 0)
            {
                for (int i = 0; i < ileTileNaEkranie; i++)
                {
                    g.DrawImage(tileImageList[i],tileDataList[i,4],tileDataList[i,3]);

                }
            }


        }

        
        //konwertuj dane na kod dla assemblera ZX Spectrum
        private void btnWynik_Click(object sender, EventArgs e)
        {
            tbxWynik.Text = "";
            #region zapisywanie bloków
            tbxWynik.Text += Environment.NewLine + ";blocks" + Environment.NewLine;
            //wykonaj 3 pętle przeszukujące tablice tilesów dla 3 segmentów ekranu Spectrum

            //segment 1
            for (int i = 0; i < ileBlockNaEkranie; i++)
            {
                if (blockDataList[i, 1] == 64)
                {
                    tbxWynik.Text += " .BYTE " + blockDataList[i, 0].ToString() + "," 
                                               + blockDataList[i, 3].ToString()+"," 
                                               + blockDataList[i, 4].ToString() + "," 
                                               + blockDataList[i, 2].ToString() + Environment.NewLine;

                }
            }
            tbxWynik.Text += " .BYTE 0" + Environment.NewLine;

            //segment 2
            for (int i = 0; i < ileBlockNaEkranie; i++)
            {
                if (blockDataList[i, 1] == 72)
                {
                    tbxWynik.Text += " .BYTE " + blockDataList[i, 0].ToString() + ","
                                               + blockDataList[i, 3].ToString() + ","
                                               + blockDataList[i, 4].ToString() + ","
                                               + blockDataList[i, 2].ToString() + Environment.NewLine;

                }
            }
            tbxWynik.Text += " .BYTE 0" + Environment.NewLine;

            //segment 3
            for (int i = 0; i < ileBlockNaEkranie; i++)
            {
                if (blockDataList[i, 1] == 80)
                {
                    tbxWynik.Text += " .BYTE " + blockDataList[i, 0].ToString() + ","
                                               + blockDataList[i, 3].ToString() + ","
                                               + blockDataList[i, 4].ToString() + ","
                                               + blockDataList[i, 2].ToString() + Environment.NewLine;

                }
            }
            tbxWynik.Text += " .BYTE 0" + Environment.NewLine;

            #endregion


            #region zapisywanie tilesów
            tbxWynik.Text += Environment.NewLine+";tiles"+Environment.NewLine;
            //wykonaj 3 pętle przeszukujące tablice tilesów dla 3 segmentów ekranu Spectrum
            
        //segment 1
            for (int i = 0; i < ileTileNaEkranie; i++)
            {
                if (tileDataList[i, 1] == 64)
                {
                    tbxWynik.Text += " .BYTE " + tileDataList[i, 0].ToString() + "," +tileDataList[i, 2].ToString()+Environment.NewLine;
                  
                }
            }
            tbxWynik.Text += " .BYTE 0" + Environment.NewLine;

        //segment 2
            for (int i = 0; i < ileTileNaEkranie; i++)
            {
                if (tileDataList[i, 1] == 72)
                {
                    tbxWynik.Text += " .BYTE " + tileDataList[i, 0].ToString() + "," + tileDataList[i, 2].ToString() + Environment.NewLine;

                }
            }
            tbxWynik.Text += " .BYTE 0" + Environment.NewLine;

        //segment 3
            for (int i = 0; i < ileTileNaEkranie; i++)
            {
                if (tileDataList[i, 1] == 80)
                {
                    tbxWynik.Text += " .BYTE " + tileDataList[i, 0].ToString() + "," + tileDataList[i, 2].ToString() + Environment.NewLine;

                }
            }
            tbxWynik.Text += " .BYTE 0" + Environment.NewLine;
#endregion

            tbxWynik.Copy();
        }

        //cofanie ostatniego tile
        private void btnCofnijTile_Click(object sender, EventArgs e)
        {
            if (ileTileNaEkranie == 0) return; //nie ma żadnych tile - nic nie rób

            tileNr--;
            ileTileNaEkranie--;
            tileImageList[tileNr] = null;   //usuń obrazek z tablicy

            //wymaz dane obrazka z tablicy
            tileDataList[tileNr, 0] = 0; //nr obrazka
            tileDataList[tileNr, 1] = 0; //współrzędne HL dla ZxSpectrum
            tileDataList[tileNr, 2] = 0;
            tileDataList[tileNr, 3] = 0; //pozycja na ekranie
            tileDataList[tileNr, 4] = 0;

            this.Refresh();
        }

        //cofanie ostatniego bloku
        private void btnCofnijBlock_Click(object sender, EventArgs e)
        {
            if (ileBlockNaEkranie == 0) return; //nie ma żadnych bloków - nic nie rób

            blockNr--;
            ileBlockNaEkranie--;

            blockImageList[blockNr] = null;
            //usuń dane obrazka do tablicy
            blockDataList[blockNr, 0] = 0; 
            blockDataList[blockNr, 1] = 0;          
            blockDataList[blockNr, 2] = 0;
            blockDataList[blockNr, 3] = 0;
            blockDataList[blockNr, 4] = 0;
            blockDataList[blockNr, 5] = 0;
            blockDataList[blockNr, 6] = 0;
            
            this.Refresh();
        }

      

    
    }

}

       
