Nr_Items EQU 9			;temp




;--------------
DrawItems
	;LD HL,ItemDataLvl_1
	LD HL,(ItemData)
	LD B,Nr_Items				;nr of items per level
DrawItems2
	LD C,(HL)
	LD A,(LocationX)				;position_X equal?
	CP C
	JR NZ,DrawItems5				;no, go to next item (1 byte was read)
	INC HL
	LD C,(HL)
	LD A,(LocationY)				;position_Y equal?
	CP C
	JR NZ,DrawItems6				;no, go to next item (2 bytes wre read)
	
;there is an item in current location

;check if item was already picked
	LD A,Nr_Items+1			;item nr: B=7 -> nr=1, B=6 -> nr=2 ...
	SUB B							;A=(number of items)-B
	LD DE,ItemsStatus-1
DrawItems3
	INC DE
	DEC A
	JR NZ,DrawItems3
	LD A,(DE)						;find and read item status
	OR A
	RET NZ							;status <>0, item already taken
		
	LD A,Nr_Items+1
	SUB B
	LD (CurrentItemNr),A			;write item nr into variable
	
;draw the item
	INC HL							;read position
	LD D,(HL)
	INC HL
	LD E,(HL)
	PUSH DE
	EX DE,HL
	LD DE,NuclearBox				
	CALL DrawTile					;draw item
	
;set item variables
	POP DE
	LD HL,CurrentItemH
	LD (HL),D
	INC HL
	LD (HL),E
	RET

;go to next item	
DrawItems5	
	INC HL							;skip necessary nr of bytes
DrawItems6
	INC HL	
	INC HL	
	INC HL	
	DJNZ DrawItems2
	RET


;--------------
DrawSwitches
	LD HL,(SwitchesData)
	LD A,(Nr_Switches)
	LD B,A							;nr of switches per level
DrawSwitches2
	LD C,(HL)
	LD A,(LocationX)				;position_X equal?
	CP C
	JR NZ,DrawSwitches5				;no, go to next switch (1 byte was read)
	INC HL
	LD C,(HL)
	LD A,(LocationY)				;position_Y equal?
	CP C
	JR NZ,DrawSwitches6				;no, go to next switch (2 bytes wre read)
	
;there is an switch in current location

;check if switch is turned on or off
	LD A,(Nr_Switches)
	INC A							;switch nr: B=7 -> nr=1, B=6 -> nr=2 ...
	SUB B							;A=(number of switches)-B
	LD  (CurrentSwitchNr),A			;store switch nr
							
	LD DE,SwitchesStatus-1
DrawSwitches3
	INC DE
	DEC A
	JR NZ,DrawSwitches3
	LD A,(DE)						;find and read switch status
	LD DE,SwitchOn					;choose graphics
	OR A
	JR Z,DrawSwitches31
	LD DE,SwitchOff
	
;draw the switch
DrawSwitches31
	INC HL							;read position
	LD B,(HL)
	LD A,B
	LD (CurrentSwitchH),A			;store switch position
	
	INC HL
	LD C,(HL)
	LD A,C
	LD (CurrentSwitchL),A
	
	LD H,B
	LD L,C
	CALL DrawTile					;draw switch
	
	RET

;go to next item	
DrawSwitches5	
	INC HL							;skip necessary nr of bytes
DrawSwitches6
	INC HL	
	INC HL	
	INC HL	
	DJNZ DrawSwitches2
	RET


;--------------
DrawDoors
	LD HL,(DoorsData)	
	LD A,(Nr_Doors)
	LD B,A							;nr of doors per level
DrawDoors2
	LD C,(HL)
	LD A,(LocationX)				;position_X equal?
	CP C
	JR NZ,DrawDoors5				;no, go to next door (1 byte was read)
	INC HL
	LD C,(HL)
	LD A,(LocationY)				;position_Y equal?
	CP C
	JR NZ,DrawDoors6				;no, go to next door (2 bytes wre read)
	
;there is an door in current location
	INC HL							;read position
	LD D,(HL)
	INC HL
	LD E,(HL)
	INC HL
	LD C,(HL)						;read height

;check if door is opened or not
	INC HL
	LD B,(HL)						;read nr of responsible switch
	LD HL,SwitchesStatus-1
DrawDoors3
	INC HL
	DJNZ DrawDoors3
	LD A,(HL)						;find and read switch status
	OR A
	RET NZ							;sitch status<>0 -> door opened, don't draw it
	
	
;draw the door
	EX HL,DE						;position into HL
	LD B,1							;C=height,b=width=1
	LD DE,Door1						;graphics
	CALL TileBlock
	RET

;go to next door	
DrawDoors5	
	INC HL							;skip necessary nr of bytes
DrawDoors6
	INC HL	
	INC HL	
	INC HL	
	INC HL
	INC HL
	DJNZ DrawDoors2
	RET
	
	



;------------------



NuclearBox
	.BYTE 2,2
	.BYTE	  0,127,120,120,124,124,126,126
	.BYTE	  0,254, 30, 30, 62, 62,126,126
	.BYTE	120, 64, 65, 67, 99,119,127,  0
	.BYTE	 30,  2,130,194,198,238,254,  0
	.BYTE	 86, 22, 86, 22
	
Door1
	.BYTE 2,1
	.BYTE	181,186,181,186,181,186,181,186
	.BYTE	 81,169, 81,169, 81,169, 81,169
	.BYTE	 70,  6

;------------------
ClearItemsData
	XOR A
	LD B,6
	LD HL,CurrentItemH
ClearItemsData2
	LD (HL),A
	INC HL
	DJNZ ClearItemsData2
	RET
	
CurrentItemH		.BYTE 0
CurrentItemL		.BYTE 0
CurrentItemNr		.BYTE 0
CurrentSwitchH		.BYTE 0
CurrentSwitchL		.BYTE 0
CurrentSwitchNr		.BYTE 0
TouchStatus			.BYTE 0			;is ship touching item or switch 

;-----------------
CheckTakingItem
	LD HL,CurrentItemH	
	LD D,(HL)						;read item position
	INC HL
	LD E,(HL)
	EX DE,HL
	
	LD DE,NuclearBox+2
	CALL ComparePictures			;set status=1 if touching, else status=0
	RET
	
;----------------
TakeItem
;increase number of items
	LD HL,RadioactivesNr
	INC (HL)
;add one turning change for each item
	LD A,(RotationNr)
	CP 9
	JR Z,TakeItem1					;max=9
	INC A
	LD (RotationNr),A
	
TakeItem1	
	CALL DrawGameMenuNumbers
	
;change item status
	LD A,(CurrentItemNr)
	LD B,A
	LD HL,ItemsStatus-1
TakeItem2
	INC HL
	DJNZ TakeItem2
	LD A,255
	LD (HL),A

;remove item from the screen
	CALL ClearPlayer
	LD A,(CurrentItemH)
	LD H,A
	LD A,(CurrentItemL)
	LD L,A
	LD DE,Empty
	CALL DrawTile
	CALL DrawPlayer
	
;clear item data in current location
	XOR A
	LD (CurrentItemH),A
	LD (CurrentItemL),A
	LD (CurrentItemNr),A

	LD A,4
	LD (23624),A		;border colour for sound
	CALL Sound3	
	RET
	
;--------------
CheckTouchingSwitch	
	LD HL,CurrentSwitchH	
	LD D,(HL)						;read switch position
	INC HL
	LD E,(HL)
	EX DE,HL
	
;determine if switch is on or off
	LD A,(CurrentSwitchNr)
	LD DE,SwitchesStatus-1	
CheckTouchingSwitch2
	INC DE
	DEC A
	JR NZ,CheckTouchingSwitch2
	LD A,(DE)						;read status
	OR A
	JR NZ,CheckTouchingSwitch3		;switch off
	
;checking for switch on	
	LD DE,SwitchOn+2
	CALL ComparePictures			;set status=1 if touching, else a=0
	LD A,(TouchStatus)
	OR A
	RET Z							;not touching
	LD A,2
	LD (TouchStatus),A				;change status to 2 for touching
	RET								;to distinguish it from touching switch off
	
;checking for switch off
CheckTouchingSwitch3
	LD DE,SwitchOff+2
	CALL ComparePictures			;set status=1 if touching, else status=0
	RET
	
;----------------------
PushSwitch
;change switch status and open door

;change switch status
	LD A,(CurrentSwitchNr)
	LD B,A
	LD HL,SwitchesStatus-1
PushSwitch2
	INC HL
	DJNZ PushSwitch2
	LD A,255						;change switch status to off
	LD (HL),A						;it will influence door drawing routine which checks the switch status
	
;change switch sprite
	CALL ClearPlayer
	LD A,(CurrentSwitchH)
	LD H,A
	LD A,(CurrentSwitchL)
	LD L,A
	LD DE,SwitchOff
	CALL DrawTile
	CALL DrawPlayer
	
	LD A,4
	LD (23624),A		;border colour for sound
	CALL Sound2	
	RET
;---------------------
ComparePictures
;is sprite of item or switch on screen the same as original sprite?
;if it isn't = it was XORed by the ship = ship is tocuhing it
;HL-screen position, DE-sprite address
	XOR A
	LD (TouchStatus),A

;left top square
	PUSH HL
	CALL ComparePictures_Char
	POP HL		
;right top square
	INC L
	PUSH HL
	CALL ComparePictures_Char
	POP HL	
;left bottom square
	LD A,L
	ADD A,31						;go one char line down
	LD L,A
	JR NC,ComparePictures2	
	LD A,H
	ADD A,8
	LD H,A
	
ComparePictures2
	PUSH HL
	CALL ComparePictures_Char
	POP HL
;right bottom square
	INC L
	CALL ComparePictures_Char
	RET
	
;--------
ComparePictures_Char
	LD B,8
ComparePictures_Char2
	LD C,(HL)
	LD A,(DE)
	CP C							;compare sprite to screen
	JR NZ,ComparePictures_Char3		;difference=ship is touching
ComparePictures_Char21	
	INC H
	INC DE
	DJNZ ComparePictures_Char2
	RET
	
ComparePictures_Char3
	LD A,1							;mark difference
	LD (TouchStatus),A			;and continue checking - it is easier to code it this way
	JR ComparePictures_Char21

CompareStatus		.BYTE 0


;------------------
;LEVEL DATA


ItemsStatus
;0 - item not picked, 255 - item picked
	.BYTE 0
	.BYTE 0
	.BYTE 0
	.BYTE 0
	.BYTE 0
	.BYTE 0
	.BYTE 0
	.BYTE 0
	.BYTE 0
	
SwitchesStatus
;0 - switch on (door closed), 255 switch off (door opened)
	.BYTE 0
	.BYTE 0
	.BYTE 0
	.BYTE 0
	.BYTE 0
	.BYTE 0
	.BYTE 0
	.BYTE 0
	.BYTE 0
	
	
;--------------
;position of items
ItemDataLvl_1
	.BYTE 1,4,72,198		;location-X,location-Y, position-H, position-L
	.BYTE 1,2,72,236
	.BYTE 2,2,80,137
	.BYTE 3,2,72,231
	.BYTE 3,1,72,14	
	.BYTE 4,4,72,77	
	.BYTE 3,4,72,35	
	.BYTE 5,3,64,215
	.BYTE 5,1,64,117	
	
;position of switches
SwitchDataLvl_1
	.BYTE 1,1,72,119		;location-X,location-Y, position-H, position-L
	.BYTE 3,2,80,53
	.BYTE 5,4,72,183
	.BYTE 2,1,72,163
	
DoorsDataLvl_1
	.BYTE 3,3,64,141,16,1	;location-X,location-Y, position-H, position-L,height,switch nr
	.BYTE 5,4,72,77,8,2
	.BYTE 2,1,72,38,10,3
	.BYTE 5,3,64,234,6,4

;---------------	
ItemDataLvl_2
	.BYTE 2,4,80,69
	.BYTE 3,3,72,10
	.BYTE 4,3,72,237
	.BYTE 5,4,80,97
	.BYTE 3,1,72,14
	.BYTE 5,1,72,135
	.BYTE 4,2,72,172
	.BYTE 1,3,80,6
	.BYTE 2,2,64,196

SwitchDataLvl_2
	.BYTE 4,2,64,196
	.BYTE 1,2,72,183
	.BYTE 4,4,80,72
	
DoorsDataLvl_2
	.BYTE 1,2,72,20,12,1
	.BYTE 4,3,64,89,20,2
	.BYTE 2,3,64,209,10,3

;---------------	
ItemDataLvl_3
	.BYTE 1,1,64,148
	.BYTE 4,1,72,172
	.BYTE 2,2,80,141
	.BYTE 1,3,72,236
	.BYTE 1,4,80,174
	.BYTE 3,3,80,141
	.BYTE 2,3,72,68
	.BYTE 5,3,64,173
	.BYTE 5,1,64,163

SwitchDataLvl_3
	.BYTE 4,4,80,1
	.BYTE 3,4,80,145
	.BYTE 4,1,80,150
	
DoorsDataLvl_3
	.BYTE 1,2,64,45,11,1
	.BYTE 4,1,64,48,14,2
	.BYTE 4,2,64,58,21,3

;---------------	
ItemDataLvl_4
	.BYTE 2,3,80,7
	.BYTE 3,3,64,176
	.BYTE 3,4,80,140
	.BYTE 4,4, 80,134	
	.BYTE 2,2,72,69
	.BYTE 4,1,72,173
	.BYTE 1,1,64,176
	.BYTE 5,1,64,183
	.BYTE 5,3,80,52


SwitchDataLvl_4
	.BYTE 5,4,80,55
	.BYTE 1,4,72,195
	.BYTE 1,2,64,180
	.BYTE 3,1,64,141
	
DoorsDataLvl_4
	.BYTE 1,4,72,12,11,1
	.BYTE 2,1,64,132,16,2
	.BYTE 2,2,64,72,10,3
	.BYTE 5,3,72,208,8,4