;------------------------
;general enemy  routines
ClearEnemyData
;clearing enemy data when players ship enters a new location

	XOR A
	
	LD HL,FanData			;clear rotating fan data
	LD B,30
ClearEnemyData1
	LD (HL),A
	INC HL
	DJNZ ClearEnemyData1
	
	LD HL,EnemyX			;clear enemy ships data
	LD B,14
ClearEnemyData2
	LD (HL),A
	INC HL
	DJNZ ClearEnemyData2						
	
	RET	
	
	
;------------
ClearEnemies
	LD A,(EnemyStatus)
	OR A
	RET Z					;no enemies in this room

	PUSH AF
	CP 1
	CALL Z, ClearFan
	POP AF
	
	CP 2
	CALL NC,ClearEnemyShip
	
	RET
	
MoveEnemies
	LD A,(EnemyStatus)
	OR A
	RET Z					;no enemies in this room

	PUSH AF
	CP 1
	CALL RotateFan
	POP AF
	
	CP 2
	CALL NC,MoveEnemyShip
	RET	
	
	
DrawEnemies	
	LD A,(EnemyStatus)
	OR A
	RET Z					;no enemies in this room
	
	PUSH AF
	CP 1
	CALL DrawFan
	POP AF
	
	CP 2
	CALL NC,DrawEnemyShip
	
	RET
;FAN
;----------------------------------------------

SetFan
;initiate rotating fan data
;DE:Start of fan data (d:collumn,e:row)
;BC,HL:used
	
;turn row and collumn inot pixel coordinates
	LD A,2
	RLC D
	RLC D
	RLC D
	ADD A,D
	LD (FanCenterX),A	
	LD A,2
	RLC E
	RLC E
	RLC E
	ADD A,E
	LD (FanCenterY),A

;draw fan center
	LD B,D				
	LD C,E	

	CALL XYtoHL
	LD DE,FanCenterGraph
	LD B,8
SetFan2
	LD A,(DE)
	LD (HL),A
	INC DE
	INC H
	DJNZ SetFan2
	
	
	
;clear fan old data
	XOR A
	LD DE,FanPart1A_HL
	LD B,28
SetFan3
	LD (DE),A
	INC DE
	DJNZ SetFan3
	
;write some new angles
	LD A,45
	LD (FanPart1B_Angle),A
	LD A,92
	LD (FanPart2B_Angle),A

;prepare fan data and draw it for the first time
	CALL RotateFan
	CALL DrawFan	
	
	RET

FanCenterGraph	
	.BYTE	 60, 66,153,181,169,145, 66, 60


;----------------------------------------------
;rotating fan

ClearFan
	LD HL,(FanPart1A_HL)
	LD DE,(FanPart1A_Sprite)
	CALL XDrawFan			;XOR over graphics = clear graphics

	LD HL,(FanPart1B_HL)
	LD DE,(FanPart1B_Sprite)
	CALL XDrawFan			;XOR over graphics = clear graphics
	
	LD HL,(FanPart2A_HL)
	LD DE,(FanPart2A_Sprite)
	CALL XDrawFan			;XOR over graphics = clear graphics
	
	LD HL,(FanPart2B_HL)
	LD DE,(FanPart2B_Sprite)
	CALL XDrawFan			;XOR over graphics = clear graphics
	RET
	
;----------------------------------	
RotateFan
	
;part1A
	LD A,(FanPart1A_Angle)		;increase angle by one twice slower as bigger circle
	LD D,A						;(bigger circle has twice more points)
	LD A,(FanPart2A_Angle)		;so we go to next pixel in smaller circle
	AND 00000001b				;only at every second pixel (even one) in bigger circle
	ADD A,D
	
	CP 92						;full circle = 184 points
	JR NZ,RotateFan1A	
	XOR A						;if full circle was covered, start from beginning

RotateFan1A
	LD (FanPart1A_Angle),A	
	
	LD HL,Circle2Data			;find  position vector for current angle
	LD E,A
	LD D,0
	ADD HL,DE					;HL=HL+2*A (because each point takes 2 bytes)
	ADD HL,DE
	
	LD B,(HL)					;read position vector
	INC HL
	LD C,(HL)

;find new fan part coordinates
	LD A,(FanCenterX)			;X
	ADD A,B
	LD (FanPart1A_X),A
						
	LD A,(FanCenterY)			;Y
	ADD A,C
	LD (FanPart1A_Y),A
	
;---------------	
;part1B
	LD A,(FanPart1B_Angle)		;increase angle by one twice slower as bigger circle
	LD D,A						;(bigger circle has twice more points)
	LD A,(FanPart2A_Angle)		;so we go to next pixel in smaller circle
	AND 00000001b				;only at every second pixel (even one) in bigger circle
	ADD A,D
	
	CP 92						;full circle = 184 points
	JR NZ,RotateFan1B	
	XOR A						;if full circle was covered, start from beginning

RotateFan1B
	LD (FanPart1B_Angle),A	
	
	LD HL,Circle2Data			;find  position vector for current angle
	LD E,A
	LD D,0
	ADD HL,DE					;HL=HL+2*A (because each point takes 2 bytes)
	ADD HL,DE
	
	LD B,(HL)					;read position vector
	INC HL
	LD C,(HL)

;find new fan part coordinates
	LD A,(FanCenterX)			;X
	ADD A,B
	LD (FanPart1B_X),A
						
	LD A,(FanCenterY)			;Y
	ADD A,C
	LD (FanPart1B_Y),A


;---------------
;part2A
	LD A,(FanPart2A_Angle)
	INC A
	CP 184						;full circle = 184 points
	JR NZ,RotateFan2A	
	XOR A						;if full circle was covered, start from beginning

RotateFan2A
	LD (FanPart2A_Angle),A	
	
	LD HL,Circle1Data			;find  position vector for current angle
	LD E,A
	LD D,0
	ADD HL,DE					;HL=HL+2*A (because each point takes 2 bytes)
	ADD HL,DE
	
	LD B,(HL)					;read position vector
	INC HL
	LD C,(HL)

;find new fan part coordinates
	LD A,(FanCenterX)			;X
	ADD A,B
	LD (FanPart2A_X),A
						
	LD A,(FanCenterY)			;Y
	ADD A,C
	LD (FanPart2A_Y),A

;---------------
;part2B
	LD A,(FanPart2B_Angle)
	INC A
	CP 184						;full circle = 184 points
	JR NZ,RotateFan2B	
	XOR A						;if full circle was covered, start from beginning

RotateFan2B
	LD (FanPart2B_Angle),A	
	
	LD HL,Circle1Data			;find  position vector for current angle
	LD E,A
	LD D,0
	ADD HL,DE					;HL=HL+2*A (because each point takes 2 bytes)
	ADD HL,DE
	
	LD B,(HL)					;read position vector
	INC HL
	LD C,(HL)

;find new fan part coordinates
	LD A,(FanCenterX)			;X
	ADD A,B
	LD (FanPart2B_X),A
						
	LD A,(FanCenterY)			;Y
	ADD A,C
	LD (FanPart2B_Y),A
	

	RET	
	
	
;-------------------------------
DrawFan

;part1A
	LD A,(FanPart1A_X)
	LD B,A
	LD A,(FanPart1A_Y)
	LD C,A
	CALL FindFanSprite				;after that routine HL= screen position, DE=graphics
	LD (FanPart1A_HL),HL			;store position
	LD (FanPart1A_Sprite),DE		;store sprite
	CALL XDrawFan					;draw using DE and HL

;part1B
	LD A,(FanPart1B_X)
	LD B,A
	LD A,(FanPart1B_Y)
	LD C,A
	CALL FindFanSprite				;after that routine HL= screen position, DE=graphics
	LD (FanPart1B_HL),HL			;store position
	LD (FanPart1B_Sprite),DE		;store sprite
	CALL XDrawFan					;draw using DE and HL	
	
;part2A
	LD A,(FanPart2A_X)
	LD B,A
	LD A,(FanPart2A_Y)
	LD C,A
	CALL FindFanSprite				;after that routine HL= screen position, DE=graphics
	LD (FanPart2A_HL),HL			;store position
	LD (FanPart2A_Sprite),DE		;store sprite
	
	CALL XDrawFan					;draw using DE and HL

;part2B
	LD A,(FanPart2B_X)
	LD B,A
	LD A,(FanPart2B_Y)
	LD C,A
	CALL FindFanSprite				;after that routine HL= screen position, DE=graphics
	LD (FanPart2B_HL),HL			;store position
	LD (FanPart2B_Sprite),DE		;store sprite
	
	CALL XDrawFan					;draw using DE and HL

	RET

	
	
;-------------------------	
FindFanSprite
;B: X, C: Y
	CALL XYtoHL					;put into HL screen coordinates of fan part
	PUSH HL						

;A after subroutine contains shift
	LD HL,Fan0					;start of fan data
	LD DE,8 					;size of one fan frame
	OR A
	JR Z,FindFanSprite3
	
FindFanSprite2
	ADD HL,DE
	DEC A
	JR NZ,FindFanSprite2
	
FindFanSprite3
	EX DE,HL					;start of sprite data in DE
	POP HL
	RET

;-------------------------
XDrawFan
;draw (or clear fan part using XOR method)
	LD B,4;						;number of lines
	
XDrawFan2	
	LD A,(DE)					;Satelite is 3 bytes wide
	XOR (HL)
	LD (HL),A
	INC DE
	INC L
	
	LD A,(DE)
	XOR (HL)
	LD (HL),A
	INC DE
	DEC L
	
	CALL OnePixelLineDown
	DJNZ XDrawFan2
	RET
	
;--------------------
FanData

FanCenterX					.BYTE 0
FanCenterY					.BYTE 0

		
FanPart1A_HL 				.WORD 0
FanPart1A_Sprite			.WORD 0
FanPart1A_Angle				.BYTE 0
FanPart1A_X 				.BYTE 0
FanPart1A_Y 				.BYTE 0

FanPart1B_HL 				.WORD 0
FanPart1B_Sprite			.WORD 0
FanPart1B_Angle				.BYTE 0
FanPart1B_X 				.BYTE 0
FanPart1B_Y 				.BYTE 0

FanPart2A_HL 				.WORD 0
FanPart2A_Sprite			.WORD 0
FanPart2A_Angle				.BYTE 0
FanPart2A_X 				.BYTE 0
FanPart2A_Y 				.BYTE 0

FanPart2B_HL 				.WORD 0
FanPart2B_Sprite			.WORD 0
FanPart2B_Angle				.BYTE 0
FanPart2B_X 				.BYTE 0
FanPart2B_Y 				.BYTE 0

