;------------------------------------------------
;enemy ships
SetEnemyShip
	;write enemy data from location data (HL points to enemy data)
	LD A,(EnemyStatus)
	CP 4
	JR C,SetEnemyShip2 ;enemy nr 2 or 3: first type enemy - moving only vertical
	
SetEnemyShip1	
;routine version for ship flying all around - enemy nr 4 or 5
	INC HL 
 LD A,(HL)
	LD (EnemyX),A
	LD B,A
	INC HL
 LD A,(HL)
 	LD (EnemyY),A
 	LD C,A
	INC HL
 LD A,(HL)
 	LD (EnemyLeft),A
	INC HL	
 LD A,(HL)
 	LD (EnemyRight),A
	INC HL	
 LD A,(HL)
 	LD (EnemyTop),A
	INC HL
 LD A,(HL)
 	LD (EnemyBottom),A
	INC HL
 LD A,(HL)
 	LD (EnemyXSpeed),A
	INC HL
 LD A,(HL)
 	LD (EnemyYSpeed),A
 	JR SetEnemyShip3


	
SetEnemyShip2
;routine version for ship moving only vertical, enemy nr 2 or 3	
	INC HL 
 LD A,(HL)
	LD (EnemyX),A
	LD B,A
	INC HL
 LD A,(HL)
 	LD (EnemyY),A
 	LD C,A
	INC HL
 LD A,(HL)
 	LD (EnemyTop),A
	INC HL
 LD A,(HL)
 	LD (EnemyBottom),A
	INC HL
 LD A,(HL)
 	LD (EnemyYSpeed),A
 	
 	
SetEnemyShip3 	
 	CALL XYtoHL; turn xy coordinates in BC to HL coordinates
 	LD (EnemyHL),HL
 	LD (EnemyShift),A
	
	LD A,1
	LD (EnemyShipFrame),A
	CALL FindEnemyShipGraphics
	CALL DrawEnemyShip
	RET

;------------------------------------------
FindEnemyShipGraphics
;finding start of current enemy sprite data by its current frame number
	LD A,(EnemyStatus)
	CP 2
	JR Z,FindEnemyShipA
	CP 3
	JR Z,FindEnemyShipB
	CP 4
	JR Z,FindEnemyShipC
	CP 5
	JR Z,FindEnemyShipD
;-----------	
;ship A
FindEnemyShipA
	LD HL, Enemy1_1-32
	LD DE,32
	JR FindEnemyShip2

;-----------
;ship B
FindEnemyShipB
	LD HL, Enemy2_1-32
	LD DE,32
	JR FindEnemyShip2

;-----------
;ship C
FindEnemyShipC	
	LD HL,Enemy3_R
	LD A,(EnemyXSpeed)		;going left or right?
	BIT 7,A					;going right is speed 1,2 so 7th but is off
	JR Z,FindEnemyShipC_2	;right
	LD HL,Enemy3_L			;left (going left is speed 255,254) so bit is on

FindEnemyShipC_2	
	LD DE,48
	LD A,(EnemyShift)		;find sprite shifted by proper number of pixels
	OR A
	JR Z,FindEnemyShip4
FindEnemyShipC_3
	ADD HL,DE
	DEC A
	JR NZ,FindEnemyShipC_3
	JR FindEnemyShip4

;-----------
;ship D
FindEnemyShipD	
	LD HL,Enemy4_R
	LD A,(EnemyXSpeed)		;going left or right?
	BIT 7,A
	JR Z,FindEnemyShipD_2	;right
	LD HL,Enemy4_L			;left

FindEnemyShipD_2	
	LD DE,48
	LD A,(EnemyShift)		;find sprite shifted by proper number of pixels
	OR A
	JR Z,FindEnemyShip4
FindEnemyShipD_3
	ADD HL,DE
	DEC A
	JR NZ,FindEnemyShipD_3
	JR FindEnemyShip4	
	
;-----------	
FindEnemyShip2	
	LD A,(EnemyShipFrame)
FindEnemyShip3
	ADD HL,DE
	DEC A
	JR NZ,FindEnemyShip3
	
	
FindEnemyShip4	
	LD (EnemyShipSprite),HL
	
	RET	

;------------------------------------------------
ClearEnemyShip
	LD HL,(EnemyHL)
	LD DE,(EnemyShipSprite)
	LD A,(EnemyStatus)				
	CP 4
	PUSH AF							;enemy nr 2,3 = width 2 bytes
	CALL C,XDrawEnemyA				;enemy nr 4,5 = width 3 bytes -> two drawing routines
	POP AF	
	CALL NC, XDrawEnemyB
	RET
	
;--------------------------------------------------	
MoveEnemyShip
;change enemy position
	LD HL,EnemyX		;change X position
	LD D,(HL)
	LD A,(EnemyXSpeed)
	ADD A,D
	LD (HL),A
	LD B,A
	
	LD HL,EnemyY		;change Y position
	LD D,(HL)
	LD A,(EnemyYSpeed)
	ADD A,D
	LD (HL),A
	LD C,A
	
	PUSH BC				;turn position to HL coordinates
	CALL XYtoHL
	LD (EnemyHL),HL
	LD (EnemyShift),A
	POP BC
	
;reached movement edge=change direction?
;X speed?
	LD A,(EnemyLeft)
	CP B				;compare top position to current Y position
	JR Z,MoveEnemyShip1
	LD A,(EnemyRight)
	CP B				;compare bottom position to current Y position
	JR Z,MoveEnemyShip1
	JR MoveEnemyShip2	;no edge reached
	
;change	X speed	
MoveEnemyShip1
	LD A,(EnemyXSpeed)
	CPL
	INC A
	LD (EnemyXSpeed),A		

;Y speed?	
MoveEnemyShip2
	LD A,(EnemyTop)
	CP C				;compare top position to current Y position
	JR Z,MoveEnemyShip3
	LD A,(EnemyBottom)
	CP C				;compare bottom position to current Y position
	JR Z,MoveEnemyShip3
	JR MoveEnemyShip5	;no edge reached

;change	Y speed	
MoveEnemyShip3	
	LD A,(EnemyYSpeed)
	CPL
	INC A
	LD (EnemyYSpeed),A		

;-----------------
;change enemy animation frame
;choose animation appropriate for current ship
MoveEnemyShip5
	LD A,(EnemyStatus)

;ship A	
	CP 2
	JR NZ,MoveEnemyShip6
	LD B,7; number of frames+1	
	CALL ChangeEnemyFrame_AB
	RET
		
;shipB	
MoveEnemyShip6
	CP 3
	JR NZ,MoveEnemyShip7	
	LD B,6; number of frames+1	
	CALL ChangeEnemyFrame_AB
	RET

;shipC	
MoveEnemyShip7
	CP 4
	JR NZ,MoveEnemyShip8
	CALL FindEnemyShipGraphics
	RET

;shipD
MoveEnemyShip8	
	CP 5
	RET NZ
	CALL FindEnemyShipGraphics	
	
	RET
	
;--------------------
ChangeEnemyFrame_AB
;changing animation frame for ships A and B
;B: number of frames in animation

	LD A,(GameCycle)
	AND 00000001b			
	OR A					;change sprite frame only every secong game frame
	JR Z,MoveEnemyShip6

	LD HL,EnemyShipFrame
	INC (HL)
	LD A,(HL)
	CP 6			;6 frames total
	JR NZ,ChangeEnemyFrame_AB2
	LD A,1
	LD (HL),A		;start frames from beginning
ChangeEnemyFrame_AB2
	CALL FindEnemyShipGraphics
	RET

	
;-----------------------------------------------		
DrawEnemyShip
	LD HL,(EnemyHL)
	LD DE,(EnemyShipSprite)
	LD A,(EnemyStatus)				
	CP 4
	PUSH AF							;enemy nr 2,3 = width 2 bytes
	CALL C,XDrawEnemyA				;enemy nr 4,5 = width 3 bytes -> two drawing routines
	POP AF	
	CALL NC, XDrawEnemyB
	RET

;------------------
XDrawEnemyA
;draw two bytes wide enemy, ships A,B
	
;drawing sprite
	LD B,16;					;number of lines
	
XDrawEnemyA_2	
	LD A,(DE)					;Ship is 3 bytes wide
	XOR (HL)
	LD (HL),A
	INC DE
	INC L
	
	LD A,(DE)
	XOR (HL)
	LD (HL),A
	INC DE
	DEC L
	
	CALL OnePixelLineDown
	DJNZ XDrawEnemyA_2
	RET
	
;------------------
XDrawEnemyB
;draw three bytes wide enemy, ships C,D
	CALL XDrawShip				;the same routine as for drawing player ship
	RET	
;------------------	
 
EnemyX			.BYTE 0
EnemyY			.BYTE 0
EnemyHL			.WORD 0

EnemyLeft		.BYTE 0			;edges of enemy movement
EnemyRight		.BYTE 0
EnemyTop		.BYTE 0
EnemyBottom		.BYTE 0

EnemyXSpeed		.BYTE 0
EnemyYSpeed		.BYTE 0

EnemyShipFrame	.BYTE 0
EnemyShipSprite	.WORD 0
EnemyShift		.BYTE 0