
StartMenu
;drawing start menu
	CALL ClearScreen
	XOR A
	LD (23624),A		;border colour for sound

	
;type menu texts
	LD HL,16393
	LD IX,MenuText1
	LD BC,67*256+3
	CALL TypeText
	
	LD HL,16547
	LD IX,MenuText2
	LD BC,70*256+6
	CALL TypeText
	
	LD HL,18435
	LD IX,MenuText3
	LD BC,70*256+6
	CALL TypeText
	
	LD HL,18531
	LD IX,MenuText4
	LD BC,70*256+6
	CALL TypeText
	
	LD HL,18627
	LD IX,MenuText5
	LD BC,70*256+6
	CALL TypeText
	
	LD HL,20480+139
	LD DE,Credits
	CALL DrawTile
	
	CALL 49152			;play music
	
	
StartMenu2
;testing keyboard
	LD BC,63486
	IN A,(C)
		
	BIT 0,A				;choose keys
	JR Z,SetKeys
			
	BIT 1,A				;choose kempston joystick	
	JR Z,SetJoy1
			
	BIT 2,A				;choose sinclair joystick
	JR Z,SetJoy2
	
	BIT 3,A				;starting the game
	JR Z,ChooseDiff		;and choosing difficulty level
	
	JR StartMenu2

SetKeys
	XOR A
	LD (PlayerInput),A
	CALL Sound1
	LD D,88					;position of flashing animation
	LD E,160
	CALL FlashMenuOption
	JR StartMenu2
	
SetJoy1
	LD A,1
	LD (PlayerInput),A
	CALL Sound1
	LD D,89					
	LD E,0
	CALL FlashMenuOption
	JR StartMenu2
	
SetJoy2
	LD A,2
	LD (PlayerInput),A
	CALL Sound1
	LD D,89					
	LD E,96
	CALL FlashMenuOption
	JR StartMenu2
	
;-------------	
ChooseDiff
;choosing game difficulty at the beginning of new game

	CALL Sound1
	LD D,89					
	LD E,192
	CALL FlashMenuOption
	CALL ClearEffect			;clear previous screen
	CALL ClearScreen
	
	LD HL,16384+134				;difficulty text
	LD IX,DiffText1
	LD BC,69*256+3
	 CALL TypeText
	LD HL,18432+40
	LD IX,DiffText2
	LD BC,65*256+1
	 CALL TypeText
	LD HL,18432+136
	LD IX,DiffText3
	LD BC,65*256+1
	 CALL TypeText
	 
ChooseDiff2
	LD BC,63486
	IN A,(C)
		
	BIT 0,A				;choose easy difficulty
	JR Z,ChooseDiff_Easy
			
	BIT 1,A				;choose normal difficulty
	JR Z,ChooseDiff_Norm
	
	JR ChooseDiff2
	
ChooseDiff_Easy
	LD A,255
	LD (Difficulty),A
	CALL Sound1
	CALL ClearEffect
	JP Start2
	
ChooseDiff_Norm
	XOR A
	LD (Difficulty),A
	CALL Sound1
	CALL ClearEffect
	JP Start2
	
	
	
DiffText1
 .BYTE 4,9,6,6,9,3,21,12,20,25,0
DiffText2 
 .BYTE 31,28,5,1,19,25,0
DiffText3
 .BYTE 32,28,14,15,18,13,1,12,0

;------------
FlashMenuOption
	LD C,20
FlashMenuOption2
	LD H,D
	LD L,E
	HALT
	LD B,64
FlashMenuOption3
	LD A,(HL)
	SET 0,A				;white
	LD (HL),A
	INC HL
	DJNZ FlashMenuOption3
	
	LD H,D
	LD L,E
	HALT
	LD B,64
FlashMenuOption4
	LD A,(HL)
	RES 0,A				;yellow
	LD (HL),A
	INC HL
	DJNZ FlashMenuOption4
	
	DEC C
	JR NZ,FlashMenuOption2
	RET

;-------------------------	
DrawGameMenu
	LD HL,GameMenu
	CALL DrawLocation2
	
	LD HL,18653+3*256		;position
	LD DE,Satelite3			;sprite
	CALL XDrawSatelite		;draw satelite 1 using DE and HL
	
;energy bar attributes
	LD HL,89*256+29
	LD DE,31
	LD A,2
	LD B,6
DrawGameMenu2
	LD (HL),A
	INC L
	LD (HL),A
	ADD HL,DE
	DJNZ DrawGameMenu2
	
	
	CALL DrawGameMenuNumbers
	CALL DrawEnergy
	RET

	
;--------		
DrawGameMenuNumbers
	LD HL,20480+157
	LD A,(RadioactivesNr)
	CALL DrawGameMenuNumbers2

	LD A,(Difficulty)
	OR A
	JR NZ,DrawGameMenuNumbers1		;easy level, draw inifinity instead of turns number

	LD HL,16384+157
	LD A,(RotationNr)
	CALL DrawGameMenuNumbers2
	RET

DrawGameMenuNumbers1
	LD HL,16384+157
	LD DE,Infinity
	CALL DrawTile
	RET
	
DrawGameMenuNumbers2
	ADD A,30
	LD (DummyNumberText),A
	LD IX,DummyNumberText
	LD BC,65*256+1
	CALL TypeText
	RET
	
DummyNumberText
	.BYTE 0,0
	
;--------
DrawEnergy
	LD A,(Energy)
	SRL A
	SRL A
	
	LD C,A
	LD HL,72*256+29		;top of energy bar
	
	CP 48				;no empty lines
	JR Z,DrawEnergy25	
	
;first draw empty pixel lines
	LD A,48
	SUB C				;nr of empty lines
	LD B,A	
	LD D,0
	
DrawEnergy2	
	LD (HL),D			;one line of energy bar takes 2 bytes
	INC L
	LD (HL),D
	DEC L
	CALL OnePixelLineDown
	DJNZ DrawEnergy2	
	
DrawEnergy25	
;now draw filled pixel lines
	LD A,C
	OR A
	RET Z				;no filled lines

	LD B,C
	LD D,3
	LD E,192
	
DrawEnergy3
	LD (HL),D			;one line of energy bar takes 2 bytes
	INC L
	LD (HL),E
	DEC L
	CALL OnePixelLineDown
	DJNZ DrawEnergy3	
	RET
	
;--------------
StartLevelScreen
	CALL ClearScreen
	
	LD A,(LevelNr)
	ADD A,30
	LD (StartText1+6),A	;put level nr into text
	
	LD HL,16384+169
	LD IX,StartText1
	LD BC,71*256+7
	CALL TypeText
	
	LD HL,18564-96
	LD IX,StartText2
	LD BC,69*256+5
	CALL TypeText
	
	LD HL,18664-96
	LD IX,StartText3
	LD BC,69*256+5
	CALL TypeText
	
;find level name
	LD HL,LevelNames-3
	LD A,(LevelNr)
	
StartLevelScreen2
	INC HL
	INC HL
	INC HL
	DEC A
	JR NZ,StartLevelScreen2
	
	LD C,(HL)	;position offset
	INC HL
	LD E,(HL)	;text address
	INC HL
	LD D,(HL)
	PUSH DE
	POP IX
	
	LD H,80		;count position
	LD A,0
	ADD A,C
	LD L,A
	
	LD BC,65*256+1	;color
	CALL TypeText

	CALL Wait2Sec
	CALL ClearEffect
	RET
	
LevelNames
	.BYTE 8
	.WORD Lvl1Name
	.BYTE 9
	.WORD Lvl2Name
	.BYTE 5
	.WORD Lvl3Name
	.BYTE 9
	.WORD Lvl4Name
	
	
Lvl1Name
	 .BYTE 3,25,2,5,18,14,9,1,0
Lvl2Name
	 .BYTE 5,20,5,18,14,21,13,0
Lvl3Name
	 .BYTE 20,5,3,8,14,15,16,15,12,9,19,0
Lvl4Name
	 .BYTE 9,14,6,5,18,14,15,0
	 
;---------------
Wait2Sec
	LD B,100
Wait2Sec2
	HALT
	DJNZ Wait2Sec2
	RET

;---------------
LifeLost
;death animation
	LD B,40
	
LifeLost2
	PUSH BC
	XOR A
	OUT (254),A	
	HALT
	CALL ClearPlayer
	LD A,16
	OUT (254),A	
	HALT
	HALT
	CALL DrawPlayer
	POP BC
	DJNZ LifeLost2
	CALL ClearPlayer
	HALT

;game over or not?
	LD A,(Lives)			;decrease number of lives		
	DEC A
	LD (Lives),A
	CP 255					;less than 0
	JP Z,GameOver
	
;life lost info screen
	CALL ClearScreen
	LD HL,16486+64
	LD IX,LL_txt1
	LD BC,66*256+2
	CALL TypeText
	
	LD HL,18432+64
	LD IX,LL_txt2
	LD BC,66*256+2
	CALL TypeText
	
	LD A,(Lives)
	ADD A,30
	LD (LL_txt3),A
	LD HL,18432+238
	LD IX,LL_txt3
	LD BC,70*256+6
	CALL TypeText

	CALL Wait2Sec
	CALL ClearEffect
	
	XOR A
	LD (StartingNewLevel),A	;don't erase collected items and pushed switches
	JP Start3


LL_txt1
 .BYTE 12,9,6,5,27,12,15,19,20,0
LL_txt2
 .BYTE 12,9,22,5,19,27,18,5,13,1,9,14,9,14,7,28,0
 
LL_txt3
	.BYTE 0,0
	
;---------------
GameOver
	CALL ClearEffect
	CALL ClearScreen
	LD HL,18432+103
	LD IX,GameOver_Txt
	LD BC,70*256+66
	CALL TypeText
	CALL Wait2Sec
	CALL ClearEffect
	JP Start


	
GameOver_Txt	
 .BYTE 7,1,13,5,27,15,22,5,18,0
 
 
;---------------------------
CheckWin
	LD A,(RadioactivesNr)
	CP 9
	RET NZ
	
;level completed screen
CheckWin2
	CALL ClearEffect
	CALL ClearScreen


	LD HL,18432+33
	LD IX,LvlComplete_Txt1
	LD BC,70*256+68
	CALL TypeText
	
	LD HL,18432+129
	LD IX,LvlComplete_Txt2
	LD BC,70*256+68
	CALL TypeText
	
	CALL Wait2Sec
	CALL ClearEffect
	
	LD A,(LevelNr)
	INC A
	LD (LevelNr),A		;next level
	CP 5				;end of the game?
	JR Z,Congrats
	
	LD A,(Difficulty)	;game ends after level 2 on easy difficulty
	OR A
	JR Z,CheckWin3		;normal difficulty, skip test
	
	LD A,(LevelNr)
	CP 3
	JP Z,Congrats_Easy
	
	
CheckWin3	
	LD A,1
	LD (StartingNewLevel),A		;mark starting the new level=erase items and switches data
	JP Start3	
	
LvlComplete_Txt1
	 .BYTE 3,15,14,7,18,1,20,21,12,1,20,9,15,14,19,0	
LvlComplete_Txt2
	  .BYTE 12,5,22,5,12,27,3,15,13,16,12,5,20,5,4,0

	  
;-------------
Congrats

;first screen
	CALL ClearScreen
	LD HL,18432+101
	LD IX,Congrats_Txt1
	LD BC,67*256+2
	CALL TypeText
	CALL Wait2Sec
	CALL ClearEffect
	CALL ClearScreen
	
;second screen	
	LD HL,16384+164
	LD IX,Congrats_Txt4
	LD BC,67*256+2
	CALL TypeText
	LD HL,18432+5
	LD IX,Congrats_Txt5
	LD BC,67*256+2
	CALL TypeText
	LD HL,18432+104
	LD IX,Congrats_Txt6
	LD BC,67*256+2
	CALL TypeText
	CALL Wait2Sec
	
;medal animation
	LD B,30
	
Congrats2
	PUSH BC
	
	HALT	
	HALT	
	HALT	
	LD HL,22528+512
	LD B,128
	XOR A
Congrats3
	LD (HL),A			;clear medal
	INC HL
	DJNZ Congrats3

	HALT
	HALT
	HALT	
	LD HL,20480+14		;draw medal
	LD DE,Medal
	CALL DrawTile
	
	POP BC
	DJNZ Congrats2
	
	CALL Wait2Sec
	CALL 49152			;play music
	CALL ClearEffect
	JP Start
	
Congrats_Txt1	 
 	 .BYTE 25,15,21,27,13,1,4,5,27,9,20,0
Congrats_Txt4
	.BYTE 25,15,21,18,27,2,18,1,22,5,18,25,0	 
Congrats_Txt5
 	  .BYTE 14,5,5,4,19,27,20,15,27,2,5,0
Congrats_Txt6
 	  .BYTE 18,5,23,1,18,4,5,4,0
 	
Medal
	.BYTE 3,4	    
	.BYTE	  7,  7,  3,  3,  3,  1,  1,  0
	.BYTE	 66, 66, 66, 66, 66, 66, 66, 66
	.BYTE	224,224,192,192,192,128,128,  0
	.BYTE	  0,  8, 12,  7,  6, 99, 57, 20
	.BYTE	  0,126, 60,  0,255,  0,255,129
	.BYTE	  0, 16, 48,224, 96,198,156, 40
	.BYTE	 11, 10, 10, 10, 10, 10, 10, 11
	.BYTE	126,255,255,255,253,249,115,126
	.BYTE	208, 80, 80, 80, 80, 80, 80,208
	.BYTE	 20, 57, 99,  6,  7, 12,  8,  0
	.BYTE	129,255,  0,255,  0,  0,  0,  0
	.BYTE	 40,156,198, 96,224, 48, 16,  0
	.BYTE	 66, 86, 66, 70, 70,  6, 70, 65
	.BYTE	  6, 70,  6,  6

;------------------
Congrats_Easy			;end of the game at easy difficulty after level 2 
	CALL ClearScreen
	LD HL,16384+167
	LD IX,CongratsEasy_Txt1
	LD BC,67*256+2
	 CALL TypeText
	LD HL,18432+66
	LD IX,CongratsEasy_Txt2
	LD BC,67*256+2
	 CALL TypeText
	LD HL,18432+166
	LD IX,CongratsEasy_Txt3
	LD BC,67*256+2
	 CALL TypeText
	LD HL,20480+64
	LD IX,CongratsEasy_Txt4
	LD BC,67*256+2
	 CALL TypeText
	LD HL,20480+169
	LD IX,CongratsEasy_Txt5
	LD BC,67*256+2
	 CALL TypeText
	
	CALL Wait2Sec
	CALL 49152			;play music
	CALL ClearEffect
	JP Start

CongratsEasy_Txt1	
	 .BYTE 23,5,12,12,27,4,15,14,5,0
CongratsEasy_Txt2	
 .BYTE 14,15,23,27,20,18,25,27,14,15,18,13,1,12,0
CongratsEasy_Txt3 
 .BYTE 4,9,6,6,9,3,21,12,20,25,0
CongratsEasy_Txt4
 .BYTE 13,15,18,5,27,23,15,18,12,4,19,27,23,1,9,20,0
CongratsEasy_Txt5
 .BYTE 6,15,18,27,25,15,21,0
;------------------

Sound1
	LD B,200
	LD DE,1
	LD HL,100
Sound1_2	
	PUSH BC
	PUSH DE
	PUSH HL
	CALL 949
	POP HL
	POP DE
	POP BC
	INC HL
	DJNZ Sound1_2
	RET

Sound2
	LD B,80
	LD DE,80
	LD HL,20
Sound2_2	
	PUSH BC
	PUSH DE
	PUSH HL
	CALL 949
	POP HL
	POP DE
	POP BC
	DEC E
	DJNZ Sound2_2
	RET
	
Sound3
	LD B,90
	LD DE,20
	LD HL,29
Sound3_2	
	PUSH BC
	PUSH DE
	PUSH HL
	LD A,L
	BIT 2,A
	CALL Z,949
	POP HL
	POP DE
	POP BC
	DEC L	
	DJNZ Sound3_2
	RET
	
		
;--------------------------
ClearEffect
;HL - position
;BC - number of attribute lines
	LD HL,0
	LD B,24

 	PUSH HL
	PUSH BC
	LD   HL,16384
	LD   BC,8192
	PUSH HL
	PUSH BC
	CALL ClearEffect3
	POP  BC
	POP  HL
	INC  H
	PUSH HL
	PUSH BC
	CALL ClearEffect3
	POP  BC
	POP  HL
	INC  H
	CALL ClearEffect3

;fill screen blue
	LD   HL,22528
	LD   DE,22529
	LD   BC,767
	LD   (HL),65
	LDIR
	
	POP  BC
	POP  HL
	
	LD   C,16
ClearEffect2
	PUSH HL
	PUSH BC
	HALT
	HALT
	CALL ClearEffect4
	POP  BC
	POP  HL
	DEC  C
	JP   NZ,ClearEffect2
	RET
	
;--------
ClearEffect3
	LD (HL),C
	INC HL
	DJNZ ClearEffect3
	RET
	
;-------
ClearEffect4
	PUSH HL
	PUSH BC
	CALL ClearEffect8
	AND  31
	LD   H,A
	CALL ClearEffect8
	LD   L,A
	EXX
	POP  BC
	POP  HL
	LD   A,B
	ADD  A,H
	DEC  A
	LD   H,A
	CALL ClearEffect9
	LD   A,H
	OR   7
	LD   H,A
	LD   D,H
	LD   E,L
ClearEffect5
	PUSH HL
	PUSH BC
	LD   B,8
ClearEffect6
	LD   C,L
	
	REPT 31	
	EXX
	XOR  (HL)
	INC  HL
	OR   (HL)
	EXX
	AND  (HL)
	LD   (DE),A
	INC  L
	INC  E
	ENDR
	
	EXX
	XOR  (HL)
	INC  HL
	OR   (HL)
	EXX
	AND  (HL)
	LD   (DE),A
	LD   L,C
	LD   D,H
	LD   E,L
	DEC  H
	DEC  B
	JP   NZ,ClearEffect6
	POP  BC
	POP  HL
	LD   A,L
	SUB  32
	LD   L,A
	JR   NC,ClearEffect7
	LD   A,H
	SUB  8
	LD   H,A
ClearEffect7
	DEC  B
	JP   NZ,ClearEffect5
	RET

;----------
ClearEffect8
	PUSH HL
	PUSH DE
	LD   A,R
SMC1	
	ADD  A,9				;self modyfying code
	XOR  7
	RLCA
	ADD  A,31
	LD   (SMC1+1),A
SMC2	
	LD   HL,62942
	LD   DE,29471
	ADD  HL,DE
	RLC  L
	LD   (SMC2+1),HL
	XOR  H
	XOR  L
	POP  DE
	POP  HL
	RET
	
;-----------
ClearEffect9	
	LD   A,H
	AND  7
	RRCA
	RRCA
	RRCA
	OR   L
	LD   L,A
	LD   A,H
	AND  24
	OR   64
	LD   H,A
	RET
	
;-------------------------------
Credits:
	.BYTE 9,3
	.BYTE	  0,  0, 28, 33, 45, 37, 25,  0
	.BYTE	  0,  0,149, 93,221, 85, 85,  0
	.BYTE	  0,  0,193,  9,129,  9,193,  0
	.BYTE	  0,  0,137, 85,157, 85, 85,  0
	.BYTE	  0,  0,201, 21,157, 21, 21,  0
	.BYTE	  0,  0,  1,  1,129,  1,193,  0
	.BYTE	  0,  0, 82,213,215, 85, 85,  0
	.BYTE	  0,  0,115, 20, 37, 68,115,  0
	.BYTE	  0,  0,144, 40,184,168, 40,  0
	.BYTE	  0, 42, 58, 58, 42, 43,  0,  0
	.BYTE	  0,186,162,186,138,186,  0,  0
	.BYTE	  0,225,129,137,129,233,  0,  0
	.BYTE	  0, 87,212,215, 81, 87,  0,  0
	.BYTE	  0,119, 36, 38, 36, 39,  0,  0
	.BYTE	  0, 97, 81, 97, 81, 81,  0,  0
	.BYTE	  0,157, 81,153, 81,221,  0,  0
	.BYTE	  0,220, 20,156, 16,208,  0,  0
	.BYTE 16
	.BYTE 16
	.BYTE 16
	.BYTE 16
	.BYTE	  0, 29,  5, 29, 17, 29,  0,  0
	.BYTE	  0,215, 85, 85, 85,215,  0,  0
	.BYTE 16
	.BYTE 16
	.BYTE 16
	.BYTE 16
	.BYTE	 71, 71, 71, 71, 71, 71, 71, 71
	.BYTE	 71, 71, 71, 71, 71, 71, 71, 71
	.BYTE	 71,  0,  0,  0,  0, 71, 71,  0
	.BYTE	  0,  0,  0
	
Infinity:
	.BYTE 2,2
	.BYTE	  0,  0,  0,  0, 60,126,231,195
	.BYTE	  0,  0,  0,  0, 60,126,231,195
	.BYTE	193,195,231,126, 60,  0,  0,  0
	.BYTE	131,195,231,126, 60,  0,  0,  0
	.BYTE	 65, 65,  1,  1