;---------------------------
RotateSatelites	
;rotate satelites around ship center position
	LD A,255
	LD (Sat1OnScreen),A			;let's assume that the satelites are visible on screen
	LD (Sat2OnScreen),A
	
	LD A,(RotationWaitTime)		;some time must pass since last satelites rotation change to next change
	OR A						;decrease this time if it isn't 0
	JR Z,ChangeAngle1_1	
	DEC A
	LD (RotationWaitTime),A
	
;SATELITE 1	
;change position angle
ChangeAngle1_1	
	LD A,(Rotation)				;going left or right
	OR A
	JR Z,ChangeAngle1_Right	

;-----
ChangeAngle1_Left
	LD A,(Satelite1Angle)
	DEC A
	CP 255						;carry = full circle
	JR NZ,ChangeAngle1_2	
	LD A,183					;if full circle was covered, start from beginning
	JR ChangeAngle1_2
	
;-----
ChangeAngle1_Right	
	LD A,(Satelite1Angle)
	INC A
	CP 184						;full circle = 184 points
	JR NZ,ChangeAngle1_2	
	XOR A						;if full circle was covered, start from beginning
	JR ChangeAngle1_2
	
ChangeAngle1_2
	LD (Satelite1Angle),A	
	
		
;find satelite position vector for current angle
	LD HL,Circle1Data
	LD E,A
	LD D,0
	ADD HL,DE					;HL=HL+2*A (because each point takes 2 bytes)
	ADD HL,DE
	
	
	LD B,(HL)					;read position vector
	INC HL
	LD C,(HL)

;find new satelite coordinates	
;X	
	LD A,(ShipCenterX)
	ADD A,B
	SUB 5						;correct to find left top corner
	LD B,A
	LD (Satelite1CenterX),A
	
	CP 214						;IF X>224 -> satelite 1 went off screen either from left
								;(carry, x<0 -> x about 250 or so), or went right of screen
								;(214= 224(left menu edge)-10 (satelite size) )
								
	JR C,ChangeAngle1_3			;X<224-> X OK, now check Y
	
	XOR A
	LD (Sat1OnScreen),A			;this code reached -> satelite is off screen
											
;Y	
ChangeAngle1_3	
	LD A,(ShipCenterY)
	ADD A,C
	SUB 5						;correct to find left top corner
	LD C,A
	LD (Satelite1CenterY),A	
	
	CP 181						;IF X>192 -> satelite 1 went off screen either from top
								;(carry, y<0 -> y about 250 or so), or went bottom off screen
								;(x>181 and 181 is the lowest screen line 191 minus ship height 10)
	JR C,ChangeAngle2_1			;X<192-> Y ok, go to second satelite
	
	XOR A
	LD (Sat1OnScreen),A			;this code reached -> satelite is off screen
								
								
;SATELITE 2
;(the same code as for Satellite1 but with different data)
ChangeAngle2_1	
	LD A,(Rotation)				;going left or right
	OR A
	JR Z,ChangeAngle2_Right	

;----
ChangeAngle2_Left
	LD A,(Satelite2Angle)
	DEC A
	CP 255						;carry=full circle
	JR NZ,ChangeAngle2_2	
	LD A,183					;if full circle was covered, start from beginning
	JR ChangeAngle2_2
;----
ChangeAngle2_Right	
	LD A,(Satelite2Angle)
	INC A
	CP 184						;full circle = 184 points
	JR NZ,ChangeAngle2_2	
	XOR A						;if full circle was covered, start from beginning
	JR ChangeAngle2_2
	
ChangeAngle2_2
	LD (Satelite2Angle),A	
	
		
;find satelite position vector for current angle
	LD HL,Circle1Data
	LD E,A
	LD D,0
	ADD HL,DE					;HL=HL+2*A (because each point takes 2 bytes)
	ADD HL,DE
	
	
	LD B,(HL)					;read position vector
	INC HL
	LD C,(HL)

;find new satelite coordinates	
;X	
	LD A,(ShipCenterX)
	ADD A,B
	SUB 5						;correct to find left top corner
	LD B,A
	LD (Satelite2CenterX),A
	
	CP 214						;satelite off screen?
								
	JR C,ChangeAngle2_3			;X<224-> X OK, now check Y
	
	XOR A
	LD (Sat2OnScreen),A			;this code reached -> satelite is off screen
;Y	
ChangeAngle2_3		
	LD A,(ShipCenterY)
	ADD A,C
	SUB 5
	LD C,A
	LD (Satelite2CenterY),A	
	
	CP 181						;satelite off screen?
	RET C
	
	XOR A
	LD (Sat2OnScreen),A			;this code reached -> satelite is off screen
	RET

Sat1OnScreen		.BYTE 0		;is satellite 1 in visible screen area (0- no, not 0 - yes)
Sat2OnScreen		.BYTE 0