
	
	DEVICE ZXSPECTRUM48
	ORG 27800

Start
	DI
	LD SP,65520
	EI
	
	JP StartMenu				;draw menu, after menu program jumps to Start2

Start2
;start game from beginning
	;--------------------------------

	LD A,4
	LD (Lives),A
	LD A,1						;TEMP!
	LD (LevelNr),A
	LD (StartingNewLevel),A		;mark starting the new level=erase items and switches data
	
Start3
;start level 
	DI
	LD SP,65520
	EI
	CALL SetLevel
	
	CALL StartLevelScreen

	CALL ClearScreen
	
	CALL DrawGameMenu
		
	CALL DrawLocation
	
		
;draw player ship for the first time 
;(it is necessary to do so to initiate some data)	
	CALL RotateSatelites
	CALL DrawPlayer 
	

GameDelay	
	HALT
	LD BC,1650					;interrupt delay

GameDelay2
	DEC BC
	LD A,B
	OR C
	JR NZ,GameDelay2

	
	;LD A,1						;border used for checking interrupts
	;OUT (254),A
	
;clear ship at old position	
	CALL ClearPlayer
	CALL ClearEnemies
	

	CALL MovePlayer				;change ship position
	CALL RotateSatelites		;change satelite position
	
	CALL MoveEnemies 
	
;draw player at new position	
	CALL DrawEnemies
	CALL DrawPlayer
	
	;XOR A						;border used for checking interrupts
	;OUT (254),A
	
	CALL CheckCollisions
	CALL CollisionResult
	CALL CheckWin
	
	
	LD HL,GameCycle
	INC (HL)
	
	JP GameDelay
	
	
;--------------------------------
SetLevel
	LD A,(StartingNewLevel)
	OR A
	JR Z,SetLevel_B			;starting new level or playing the same level after death=collected items and switches are remembered

	XOR A
	LD (RadioactivesNr),A
	LD HL,ItemsStatus		;clear items and switches status -> nothing is done at the beginning
	
	LD B,18
SetLevel_A
	LD (HL),A
	INC HL
	DJNZ SetLevel_A
	
	
SetLevel_B
	XOR A
	LD (Rotation),A
	LD (RotationWaitTime),A
	LD (GameCycle),A
	LD (CollisionStatus_Ship),A
	LD (CollisionStatus_Sat),A
	
	
	LD (Satelite1Angle),A
	LD A,92
	LD (Satelite2Angle),A
	
	LD A,9
	LD (RotationNr),A
	LD A,192
	LD (Energy),A
	
	LD A,(LevelNr)
	CP 1
	JP Z,SetLevel1
	CP 2
	JP Z,SetLevel2
	CP 3
	JP Z,SetLevel3
	CP 4
	JP Z,SetLevel4
	
SetLevel1
	LD A,108
	LD (ShipCenterX),A
	LD A,87
	LD (ShipCenterY),A
	LD A,1
	LD (LocationX),A
	LD A,3
	LD (LocationY),A
	
	LD A,4
	LD (Nr_Switches),A
	LD (Nr_Doors),A
	
	LD HL,ItemDataLvl_1
	LD (ItemData),HL
	LD HL,SwitchDataLvl_1
	LD (SwitchesData),HL
	LD HL,DoorsDataLvl_1
	LD (DoorsData),HL

	LD HL,Level1Map
	LD (LevelMap),HL
	RET
	
SetLevel2
	LD A,60
	LD (ShipCenterX),A
	LD A,77
	LD (ShipCenterY),A	
	LD A,1
	LD (LocationX),A
	LD A,4
	LD (LocationY),A
	LD A,3
	LD (Nr_Switches),A
	LD (Nr_Doors),A
	
	LD HL,ItemDataLvl_2
	LD (ItemData),HL
	LD HL,SwitchDataLvl_2
	LD (SwitchesData),HL
	LD HL,DoorsDataLvl_2
	LD (DoorsData),HL

	LD HL,Level2Map
	LD (LevelMap),HL
	
	;LD A,8
	;LD (RadioactivesNr),A		;TEMP!!!
	
	RET
	
SetLevel3
	LD A,98
	LD (ShipCenterX),A
	LD A,60
	LD (ShipCenterY),A	
	LD A,1
	LD (LocationX),A
	LD A,1
	LD (LocationY),A
	LD A,3
	LD (Nr_Switches),A
	LD (Nr_Doors),A
	
	LD HL,ItemDataLvl_3
	LD (ItemData),HL
	LD HL,SwitchDataLvl_3
	LD (SwitchesData),HL
	LD HL,DoorsDataLvl_3
	LD (DoorsData),HL

	LD HL,Level3Map
	LD (LevelMap),HL
	RET
	
SetLevel4
	LD A,80
	LD (ShipCenterX),A
	LD A,80
	LD (ShipCenterY),A	
	LD A,1
	LD (LocationX),A
	LD A,3
	LD (LocationY),A
	LD A,4
	LD (Nr_Switches),A
	LD (Nr_Doors),A
	
	LD HL,ItemDataLvl_4
	LD (ItemData),HL
	LD HL,SwitchDataLvl_4
	LD (SwitchesData),HL
	LD HL,DoorsDataLvl_4
	LD (DoorsData),HL

	LD HL,Level4Map
	LD (LevelMap),HL
	RET

;--------------------------------
StoreStack					.WORD 0
ShipCenterX					.BYTE 0
ShipCenterY					.BYTE 0
ShipHL						.WORD 0
ShipSprite					.WORD 0

Satelite1Angle				.BYTE 0
Satelite1CenterX			.BYTE 0			
Satelite1CenterY			.BYTE 0
Satelite1HL					.WORD 0
Satelite1Sprite				.WORD 0		;address of satelite 1 sprite

Satelite2Angle				.BYTE 92
Satelite2CenterX			.BYTE 0			
Satelite2CenterY			.BYTE 0
Satelite2HL					.WORD 0
Satelite2Sprite				.WORD 0		;address of satelite 2 sprite

Rotation					.BYTE 0		;0 - satellites go right, 1 - sattelites go left
RotationWaitTime			.BYTE 0		;some time must pass since last rotation change to next change

PlayerInput					.BYTE 0		;0-keyboard 1-kempston 2-sinclair
GameCycle					.BYTE 0

CollisionStatus_Ship		.BYTE 0
CollisionStatus_Sat			.BYTE 0


LocationX					.BYTE 0		;position of current location on level map
LocationY					.BYTE 0
CurrentLocation				.WORD 0

Lives						.BYTE 3
LevelNr						.BYTE 1
RadioactivesNr				.BYTE 0
RotationNr					.BYTE 7
Energy						.BYTE 192	;192=4*48 - full energy
EnemyStatus					.BYTE 0		;which enemy is in present location

Nr_Switches					.BYTE 0 	;on current level
Nr_Doors					.BYTE 0 

ItemData					.WORD 0		;address of data for current level
SwitchesData				.WORD 0
DoorsData					.WORD 0

Difficulty					.BYTE 0
StartingNewLevel			.BYTE 0		;are we starting a new level form beginning
										;if yes - clear the item and switches data, if not
										;(player died when playing current level)-don't clear
LevelMap					.WORD 0
		
			INCLUDE <Graphics1.asm>
			INCLUDE <Graphics2.asm>
			INCLUDE <Menu.asm>
			INCLUDE <Text.asm>		
			INCLUDE <DrawLocation.asm>
			INCLUDE <Locations.asm>
			INCLUDE <Enemy_Fan.asm>
			INCLUDE <Enemy_Ship.asm>
			INCLUDE <MoveShip.asm>
			INCLUDE <MoveSatellites.asm>
			INCLUDE <Actions.asm>
			INCLUDE <Circle.asm>
			ORG 49152
			INCBIN <PhaetonMusic.bin>
			
			
			
			SAVESNA "Phaeton.sna",Start
			SAVEBIN "Phaeton_bin.bin",27800,26982